<?php
/**
*
* @package jQ User Map api3 v.0.0.3 | User Weather Map v.0.0.3
* @version $Id: functions_user_map.php 2356 2012-05-09 02:10:24Z 4seven $
* @copyright (c) 2012 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

##############
// CONFIG AREA

// Note: Use only one of the three geocode service

// Enter as given: true or false

// GOOGLE API
// Google Basic Api
$google_api = true;

// OPEN API
// Mapquestapi Nominatim Api
$nomina_api = false;

// OPEN API
// Mapquestapi Geocoding Api
$geocod_api = false;

// Note: Use only one of the three geocode service 

// CONFIG AREA
##############

if(isset($user_id))
{
	
$profile_fieldz = array();

//viewprofile custom profile view should be enabled, because it will controll this cpf

if ($config['load_cpf_viewprofile'])
{
$c_uw = new custom_profile();
$profile_fieldz = $c_uw->generate_profile_fields_template('grab', $user_id);
$profile_fieldz = (isset($profile_fieldz[$user_id])) ? $c_uw->generate_profile_fields_template('show', false, $profile_fieldz[$user_id]) : array();
}				

// building  profile fields	
$profile_fields_towns = (isset($profile_fieldz['row']['PROFILE_USER_MAP_WEATHER_VALUE']) && (!empty($profile_fieldz['row']['PROFILE_USER_MAP_WEATHER_VALUE']))) ? $profile_fieldz['row']['PROFILE_USER_MAP_WEATHER_VALUE'] : '';
$profile_fields_towns_desc = (isset($profile_fieldz['row']['PROFILE_USER_MAP_DESC_VALUE']) && (!empty($profile_fieldz['row']['PROFILE_USER_MAP_DESC_VALUE']))) ? $profile_fieldz['row']['PROFILE_USER_MAP_DESC_VALUE'] : '';

// update location desc
if(!empty($profile_fields_towns_desc))
{
// update table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_location_desc = '" . $db->sql_escape($profile_fields_towns_desc) . "'
		WHERE user_id = " . (int) $user_id;
$result = $db->sql_query($sql);

} // if(!empty($profile_fields_towns_desc))

else
{
// reset table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_location_desc = 0
		WHERE user_id = " . (int) $user_id;
$result = $db->sql_query($sql);
}

// generate location data
if(!empty($profile_fields_towns))
{

$profile_fields_town_map   = str_replace(' ', '+', $profile_fields_towns);
$profile_fields_town       = str_replace(' ', '_', $profile_fields_towns);
$profile_fields_town_new   = str_replace(' ', ',', $profile_fields_towns);

// New Multi Geocode Switch
if ($google_api)
{
$geo_map = file_get_contents('http://maps.google.com/maps/api/geocode/json?address=' . $profile_fields_town_map . '&sensor=false');
$out_map = json_decode($geo_map);
$out_map_status = $out_map->status;
$out_map_true   = (strstr($out_map_status, "ZERO_RESULTS") || strstr($out_map_status, "OVER_QUERY_LIMIT"));
}
else if ($nomina_api)
{
$geo_map2 = file_get_contents('http://open.mapquestapi.com/nominatim/v1/search?format=json&q=' . $profile_fields_town_map);
$out_map2 = json_decode($geo_map2);
// var_dump($out_map2);
$out_map2_lat = (isset($out_map2[0]->lat)) ? $out_map2[0]->lat : false;
$out_map2_lon = (isset($out_map2[0]->lon)) ? $out_map2[0]->lon : false;
$out_map_true = ($out_map2_lat) ? false : true;
}
else if($geocod_api)
{
$geo_map3 = file_get_contents('http://open.mapquestapi.com/geocoding/v1/address?inFormat=json&location=' . $profile_fields_town_new);
$out_map3 = json_decode($geo_map3);
// var_dump($out_map3);
$out_map3_lat = (isset($out_map3->results[0]->locations[0]->latLng->lat)) ?  $out_map3->results[0]->locations[0]->latLng->lat : false;
$out_map3_lon = (isset($out_map3->results[0]->locations[0]->latLng->lng)) ?  $out_map3->results[0]->locations[0]->latLng->lng : false;
$out_map_true = ($out_map3_lat) ? false : true;
}
// New Multi Geocode Switch

//  only if true
if ($out_map_true === false)
{

// New Multi Geocode Switch
/*
Result Example: Lissabon Portugal
Google Map Geocode Result: 38.706932  | -9.1356321
Open Map Nominatim Result: 38.712834  | -9.132895
Open Map Geocode Result:   38.7128335 | -9.1328948
*/
if ($google_api)
{
$lat_map  = $out_map->results[0]->geometry->location->lat;
$long_map = $out_map->results[0]->geometry->location->lng;
// echo('<br />Google Map Geocode Result: '. $lat_map . ' | ' . $long_map . '<br />');
// Lissabon Portugal > Google Map Geocode Result: 38.706932 | -9.1356321
}
else if ($nomina_api)
{
$lat_map  = $out_map2_lat;
$long_map = $out_map2_lon;
// echo('Open Map Nominatim Result: '. $out_map2_lat . ' | ' . $out_map2_lon . '<br />');
// Lissabon Portugal > Open Map Nominatim Result: 38.7128335 | -9.1328948
}
else if ($geocod_api)
{
$lat_map  = $out_map3_lat;
$long_map = $out_map3_lon;
// echo('Open Map Geocode Result: '. $out_map3_lat . ' | ' . $out_map3_lon . '<br />');
// Lissabon Portugal > Open Map Geocode Result: 38.712834 | -9.132895
}
// New Multi Geocode Switch

// update table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_latitude = $lat_map, user_map_longitude = $long_map, user_map_location = '" . $db->sql_escape($profile_fields_town) . "'
		WHERE user_id = " . (int) $user_id;
$result = $db->sql_query($sql);

// error message
$err_mess = $user->lang['U_W_PANEL_LOC'] . ': <span style="color: white;">' .  $profile_fields_towns  . '</span> ' . $user->lang['U_W_PANEL_SUC'];

} // if ($out_map_true === false)

else
{
// update table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_latitude = 0, user_map_longitude = 0, user_map_location = 0, user_map_location = '" . $db->sql_escape($profile_fields_town) . "'
		WHERE user_id = " . (int) $user_id;
$result = $db->sql_query($sql);

// error message
$err_mess = $user->lang['U_W_PANEL_BAD'] . ' <span style="color: white;">' .  $profile_fields_towns  . '</span><br />' . $user->lang['U_W_PANEL_AGA'];
}

} // if(!empty($profile_fields_towns))

else
{
// reset table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_latitude = 0, user_map_longitude = 0, user_map_location = 0
		WHERE user_id = " . (int) $user_id;
$result = $db->sql_query($sql);

// error message
$err_mess = '<span style="color: white;">' . $user->lang['U_W_PANEL_LOC'] . '</span> ' . $user->lang['U_W_PANEL_EMP'];
}

} // if(isset($user_id))

else 
{

$profile_fieldz = array();

//viewprofile custom profile view should be enabled, because it will controll this cpf

if ($config['load_cpf_viewprofile']) 
{
$c_uw = new custom_profile();
$profile_fieldz = $c_uw->generate_profile_fields_template('grab', $user->data['user_id']);
$profile_fieldz = (isset($profile_fieldz[$user->data['user_id']])) ? $c_uw->generate_profile_fields_template('show', false, $profile_fieldz[$user->data['user_id']]) : array();
}				

// building  profile fields			
$profile_fields_towns = (isset($profile_fieldz['row']['PROFILE_USER_MAP_WEATHER_VALUE']) && (!empty($profile_fieldz['row']['PROFILE_USER_MAP_WEATHER_VALUE']))) ? $profile_fieldz['row']['PROFILE_USER_MAP_WEATHER_VALUE'] : '';
$profile_fields_towns_desc = (isset($profile_fieldz['row']['PROFILE_USER_MAP_DESC_VALUE']) && (!empty($profile_fieldz['row']['PROFILE_USER_MAP_DESC_VALUE']))) ? $profile_fieldz['row']['PROFILE_USER_MAP_DESC_VALUE'] : '';

// update location desc
if(!empty($profile_fields_towns_desc))
{
// update table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_location_desc = '" . $db->sql_escape($profile_fields_towns_desc) . "'
		WHERE user_id = " . (int) $user->data['user_id'];
$result = $db->sql_query($sql);

} // if(!empty($profile_fields_towns_desc))

else
{
// reset table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_location_desc = 0
		WHERE user_id = " . (int) $user->data['user_id'];
$result = $db->sql_query($sql);
}

// generate location data
if(!empty($profile_fields_towns))
{

$profile_fields_town_map   = str_replace(' ', '+', $profile_fields_towns);
$profile_fields_town       = str_replace(' ', '_', $profile_fields_towns);
$profile_fields_town_new   = str_replace(' ', ',', $profile_fields_towns);

// New Multi Geocode Switch
if ($google_api)
{
$geo_map = file_get_contents('http://maps.google.com/maps/api/geocode/json?address=' . $profile_fields_town_map . '&sensor=false');
$out_map = json_decode($geo_map);
// var_dump($out_map);
$out_map_status = $out_map->status;
$out_map_true   = (strstr($out_map_status, "ZERO_RESULTS") || strstr($out_map_status, "OVER_QUERY_LIMIT"));
}
else if ($nomina_api)
{
$geo_map2 = file_get_contents('http://open.mapquestapi.com/nominatim/v1/search?format=json&q=' . $profile_fields_town_map);
$out_map2 = json_decode($geo_map2);
// var_dump($out_map2);
$out_map2_lat = (isset($out_map2[0]->lat)) ? $out_map2[0]->lat : false;
$out_map2_lon = (isset($out_map2[0]->lon)) ? $out_map2[0]->lon : false;
$out_map_true = ($out_map2_lat) ? false : true;
}
else if($geocod_api)
{
$geo_map3 = file_get_contents('http://open.mapquestapi.com/geocoding/v1/address?inFormat=json&location=' . $profile_fields_town_new);
$out_map3 = json_decode($geo_map3);
// var_dump($out_map3);
$out_map3_lat = (isset($out_map3->results[0]->locations[0]->latLng->lat)) ?  $out_map3->results[0]->locations[0]->latLng->lat : false;
$out_map3_lon = (isset($out_map3->results[0]->locations[0]->latLng->lng)) ?  $out_map3->results[0]->locations[0]->latLng->lng : false;
$out_map_true = ($out_map3_lat) ? false : true;
}
// New Multi Geocode Switch

//  only if true
if ($out_map_true === false)
{

// New Multi Geocode Switch
/*
Result Example: Lissabon Portugal
Google Map Geocode Result: 38.706932  | -9.1356321
Open Map Nominatim Result: 38.712834  | -9.132895
Open Map Geocode Result:   38.7128335 | -9.1328948
*/
if ($google_api)
{
$lat_map  = $out_map->results[0]->geometry->location->lat;
$long_map = $out_map->results[0]->geometry->location->lng;
// echo('<br />Google Map Geocode Result: '. $lat_map . ' | ' . $long_map . '<br />');
// Lissabon Portugal > Google Map Geocode Result: 38.706932 | -9.1356321
}
else if ($nomina_api)
{
$lat_map  = $out_map2_lat;
$long_map = $out_map2_lon;
// echo('Open Map Nominatim Result: '. $out_map2_lat . ' | ' . $out_map2_lon . '<br />');
// Lissabon Portugal > Open Map Nominatim Result: 38.7128335 | -9.1328948
}
else if ($geocod_api)
{
$lat_map  = $out_map3_lat;
$long_map = $out_map3_lon;
// echo('Open Map Geocode Result: '. $out_map3_lat . ' | ' . $out_map3_lon . '<br />');
// Lissabon Portugal > Open Map Geocode Result: 38.712834 | -9.132895
}
// New Multi Geocode Switch

// update table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_latitude = $lat_map, user_map_longitude = $long_map, user_map_location = '" . $db->sql_escape($profile_fields_town) . "'
		WHERE user_id = " . (int) $user->data['user_id'];
$result = $db->sql_query($sql);

// error message
$err_mess = $user->lang['U_W_PANEL_LOC'] . ': <span style="color: blue;">' .  $profile_fields_towns  . '</span> ' . $user->lang['U_W_PANEL_SUC'];

} // if ($out_map_true === false)

else
{
// reset table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_latitude = 0, user_map_longitude = 0, user_map_location = 0, user_map_location = '" . $db->sql_escape($profile_fields_town) . "'
		WHERE user_id = " . (int) $user->data['user_id'];
$result = $db->sql_query($sql);

// error message
$err_mess = $user->lang['U_W_PANEL_BAD'] . ' <span style="color: blue;">' .  $profile_fields_towns  . '</span><br />' . $user->lang['U_W_PANEL_AGA'];
}

} // if(!empty($profile_fields_towns))

else
{
// reset table
$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_map_latitude = 0, user_map_longitude = 0, user_map_location = 0
		WHERE user_id = " . (int) $user->data['user_id'];
$result = $db->sql_query($sql);

// error message
$err_mess = '<span style="color: blue;">' . $user->lang['U_W_PANEL_LOC'] . '</span> ' . $user->lang['U_W_PANEL_EMP'];
}

} // else for: if $user_id is not present				

?>